/* share URL: http://www.20script.ir */

$(document).ready(function() {
	var imagelist = [];
	var bytesum = 0;
	var stop = false;
	var keepold = 0;
	var maxpx = 4096;
	var phpFile = "./imgresize.php";

	$("input.method0,.method1").prop("disabled", true);
	$("#list, #tr2").hide();
	$("#resizebtn, #stopbtn, #listbtn").prop("disabled", true);

	$("input.method0,.method1").prop("disabled", true);
	$("input.method" + $("input[type=radio]:checked").val()).prop("disabled", false);

	function shortName(n, len) {
		var ext = n.substring(n.lastIndexOf(".") + 1, n.length).toLowerCase();
		var filename = n.replace("."+ext,"");
		if(filename.length <= len) {
			return n;
		}
		filename = filename.substr(0, len) + (n.length > len ? "[...]" : "");
		return filename + "." + ext;
	};

	function bytesToSize(fileSizeInBytes) {

		var i = -1;
		var byteUnits = [" kB", " MB", " GB", " TB", "PB", "EB", "ZB", "YB"];
		do {
			fileSizeInBytes = fileSizeInBytes / 1024;
			i++;
		} while (fileSizeInBytes > 1024);

		return Math.max(fileSizeInBytes, 0.1).toFixed(1) + byteUnits[i];
	};


	function tempDisable(yorn){
		if(yorn == true) {
			var target = $("input:enabled, select:enabled");
			target.prop("disabled", true);
			target.addClass("tempdisable");
		} else if(yorn == false){
			var target = $("input.tempdisable, select.tempdisable");
			target.prop("disabled", false);
			target.removeClass("tempdisable");
		}
	};

	function isPInt(subject, max){

		if(typeof(max)==="undefined"){
			max = 0;
		}

		if($.isNumeric(subject) && subject > 0 && subject % 1 == 0){
			if(max > 0 && subject > max){
				return false;
			}
			return true;
		} else {
			return false;
		}
	};

	function inputChecks(){

		$("#resizebtn, #resizebtn").prop("disabled", true);
		$("#resizebtn, #stopbtn").prop("disabled", true);

		switch($("input[type=radio]:checked").prop("id")) {
			case "method0":
				if($("input#width").hasClass("valid") && !$("input#height").hasClass("notvalid")){
					$("#listbtn").prop("disabled", false);
				} else if ($("input#height").hasClass("valid") && !$("input#width").hasClass("notvalid")) {
					$("#listbtn").prop("disabled", false);
				} else {
					$("#listbtn").prop("disabled", true);
				}
				break;
			case "method1":
				if($("input#lrgside").hasClass("valid")){
					$("#listbtn").prop("disabled", false);
				} else {
					$("#listbtn").prop("disabled", true);
				}
				break;
			default:
				break;
		}

		if($("input#minbyte").hasClass("notvalid")){
			$("#listbtn").prop("disabled", true);
		}
	}

	function ajaxResizeCall(index, length, pbTrueLength, progressUnit, user, pw, valid) {

		var image = imagelist[index];
		var request = $.ajax({
			type : "POST",
			url : phpFile,
			data : { "action" : "resize", "i" : imagelist[index]["filename"], "w" : imagelist[index]["newwidth"], "h" : imagelist[index]["newheight"], "k" : keepold, "user" : user, "pw" : pw, "valid" : valid}
		});

		request.done(function(ajax_result) {
			var result = parseInt(ajax_result);
			if(stop == true) {
				//Process Stopped
				$("#process h3 #sspan").show();
				tempDisable(false);
				$("#stopbtn").prop("disabled", true);
				$("#stopbtn").hide();
				$("#closebtn").show();
				return false;
			}

			pbTrueLength = pbTrueLength + progressUnit;
			$("#pb").width(pbTrueLength);

			$("#fsc" + index).append(bytesToSize(result));
			bytesum += result;

			index += 1;
			$("#imgdone").html(index)

			$("#process h5").html(Math.round((index / length) * 100) + "%");

			if(index < length) {
				ajaxResizeCall(index, length, pbTrueLength, progressUnit, user, pw, valid);
			} else {
				//Process Done
				tempDisable(false);
				$("#process h3 #dspan").show();
				$("#stopbtn").prop("disabled", true);
				$("#afs").html(bytesToSize(bytesum));
				$("#closebtn").show();
				$("#stopbtn").hide();
			}
		});

		request.fail(function( jqXHR, textStatus ) {
			alert( "Request failed: " + textStatus );
			tempDisable(false);
		});
	};

	$("input, select").change( function(){
		$("#resizebtn, #resizebtn").prop("disabled", true);
		$("#resizebtn, #stopbtn").prop("disabled", true);
	});

	$("#useminbyte").change(function(){
		if($(this).prop("checked") == false){
			$("#minbyte").val("")
			$("#minbyte").removeClass("valid");
			$("#minbyte").removeClass("notvalid");
			$("label[for=useminbyte] .notice").hide();
		}
	});
	$("#minbyte").on("input", function(){
		$("#useminbyte").prop("checked", true);
	});	

	$("input#width, input#height").on("input", function(){
		var id = $(this).prop("id")
		var other = $("input#width, input#height").not("#"+id)

		if(isPInt($(this).val(), maxpx) && isPInt(other.val(), maxpx)
				|| $(this).val() == "" && isPInt(other.val(), maxpx) || other.val() == "" && isPInt($(this).val(), maxpx)){
			$("input#width, input#height").addClass("valid");
			$("label[for=method0] .notice").hide();
			$("input#width, input#height").removeClass("notvalid");
		} else {
			$("label[for=method0] .notice").css( "display", "block");
			$("input#width, input#height").addClass("notvalid");
			$("input#width, input#height").removeClass("valid");
		}
		inputChecks();

	});

	$("input#lrgside").on("input", function(){

		if(isPInt($(this).val(), maxpx)){
			$(this).addClass("valid");
			$("label[for=method1] .notice").hide();
			$(this).removeClass("notvalid");
		} else {
			$(this).addClass("notvalid");
			$("label[for=method1] .notice").css( "display", "block");
			$(this).removeClass("valid");
		}
		inputChecks();

	});

	$("input#minbyte").on("input", function(){

		if(isPInt($(this).val()) || $(this).val() == ""){
			if(isPInt($(this).val())){
				$(this).addClass("valid");
			}
			$(this).removeClass("notvalid");
			$("label[for=useminbyte] .notice").hide();
		} else {
			$(this).addClass("notvalid");
			$("label[for=useminbyte] .notice").css( "display", "block");
			$(this).removeClass("valid");
		}
		inputChecks();

	});

	$("input[type=radio]").change(function() {
		var id = $("input[type=radio]:checked").prop("id");
		var target = $("input[type=number]").not("." + id + ", #minbyte");
		var other = $("input[type=number]." + id);
		target.val("");
		target.removeClass("valid");
		target.removeClass("notvalid");

		$("label[for=method" + ( id == "method0" ? "1" : "0") + "] .notice").hide();

		target.prop("disabled", true);
		other.prop("disabled", false);

		inputChecks();
	});

	$("#stopbtn").click(function() {
		stop = true;
	});

	$( "#listbtn" ).click(function() {
		imagelist = [];
		bytesum = 0;

		$("#list, #tr2").show();

		if($("input#keepold").prop("checked")){
			keepold = 1;
		} else {
			keepold = 0;
		}

		$("#pb").width("0");
		$("#resizebtn").prop("disabled", true);

		var request = $.ajax({
			type : "POST",
			url : phpFile,
			data : "action=list&" + $("input, select").serialize()
		});

		request.done(function(ajax_result) {
			if(jQuery.isEmptyObject(ajax_result) == false){
				var result = eval(ajax_result);
				var fullByteSize = result[1];
				result = result[0];

				var html = "";

				html += "<table id=\"sizetable\"><tr> <th colspan=\"2\" id=\"tbl-title\">LIST</th> </tr>";
				html += "<tr> <th>Total Before</th> <th>Total After</th> </tr>";
				html += "<tr> <td>" + bytesToSize(fullByteSize) + "</td> <td id=\"afs\"></td> </tr>";
				html += "</table><table id=\"filetable\">";

				html += "<tr> <th></th> <th class=\"fn-cell\">Filename</th> <th>Size</th> <th>Target Size</th> <th colspan=\"2\">Filesize <br />Before | After</th></tr>";

				$.each(result, function( index, value ) {
					var sfilename = shortName(value["shownfilename"], 30);
					html += "<tr>";
					html += "<td>" + (index + 1) + "</td>";
					html += "<td class=\"fn-cell\">" + sfilename + "</td>";
					html += "<td>" + value["width"] + " x " + value["height"] + "</td>";
					html += "<td>" + value["newwidth"] + " x " + value["newheight"] + "</td>";
					html += "<td>" + bytesToSize(value["filesize"]) + "</td>";
					html += "<td id=\"fsc" + index + "\" ></td>";
					html += "</tr>";
					imagelist.push({"filename" : value["filename"], "newwidth" : value["newwidth"], "newheight" : value["newheight"]});
				});
				$("#resizebtn").prop( "disabled", false );

				html += "</table>";
				$( "#list" ).html(html);

				$("#imgtotal").html(imagelist.length);
				$("#process h5").html("0%");
				$("#imgdone").html("0")

				$("#resizebtn").prop("disabled", false);

			} else {
				$( "#list" ).html("No results.");
			}
		});

		request.fail(function( jqXHR, textStatus ) {
			alert( "Request failed: " + textStatus );
		});
	});

	$("#resizebtn").click(function() {

		$("#resizebtn").prop("disabled", true);
		
		$(".box, #resizebtn, #listbtn, #closebtn").hide();
		$("#process h3 span").hide();
		$("#process, #stopbtn").show();

		var user = $("input[name=user]").val();
		var pw = $("input[name=pw]").val();
		var valid = $("input[name=valid]").val();

		var length = imagelist.length;
		var progressUnit = $("#pb-container").width() / length;
		var pbTrueLength = 0;

		stop = false;

		tempDisable(true);

		$("#stopbtn").prop("disabled", false);

		ajaxResizeCall(0, length, pbTrueLength, progressUnit, user, pw, valid);

	});

	$("#closebtn").click(function() {
		$(".box, #resizebtn, #listbtn").show();
		$("#process").hide();
	});

});

/* share URL: http://www.bistscript.ir */