<?php
session_start();
ini_set('max_execution_time', 60);
ini_set('memory_limit', '256M');

//Change these two for safety!!!
$user = "user"; //Username for login.
$password = "pass"; //Password for login.


$startDir = dirname(__FILE__); //Starting directory.
$assetDir = 'imgrassets'; //Asset directory.
$logName = 'imageresizer.log';
$jsDir = $assetDir . '/' . 'js' . '/'; //Javascript directory.
$cssDir = $assetDir . '/' . 'css' . '/'; //CSS directory.
$maxPxRead = 4096; //Maximum pixel amount for reading. If increased, memory limit and execution time might need increasing aswell.
$maxPxWrite = 4096; //Maximum pixel amount for writing. If increased, memory limit and execution time might need increasing aswell.

require_once($assetDir . DIRECTORY_SEPARATOR . 'imgr_func.php');

if (!isset($_POST['user']) || !isset($_POST['pw']) || $_POST['user'] != $user || $_POST['pw'] != $password) {

	$formValid = mt_rand(1, 999999999); //nonce for form validation.
	if(isset($_SESSION['imgresize']['formvalid'])) unset($_SESSION['imgresize']['formvalid']);
	$_SESSION['imgresize']['formvalid'] = $formValid;

	if(isset($_POST['pw']) || isset($_POST['user'])) {
		$notice = "<div class='badlogin'>Incorrect username or password</div>";
		logMessage('Incorrect login attempt from: ' . $_SERVER['REMOTE_ADDR'] );
	} else {
		$notice = "";
	}

	$OUT = '
		<!DOCTYPE html>
		<html>
			<head>
				<meta charset="UTF-8">
				<title>IMGResize</title>
				<link rel="stylesheet" type="text/css" href="' . $cssDir . 'base.css" />
				<script></script>
			</head>
			<body>
				<div class="container" id="main">
					<h1>IMG<strong>RESIZE</strong><span id="vnum">v1.0</span></h1>
					<link rel="canonical" href="http://www.20script.ir" />
					<div class="triangle"></div>
					<form action="' . $_SERVER['PHP_SELF'] . '" method="POST">

						<div class="box login">
						'.$notice.'
							<label class="mainlabel" for="user">Username</label>
							<input type="text" name="user" placeholder="Username"/><br />
							<label class="mainlabel" for="pw">Password</label>
							<input type="password" name="pw" placeholder="*******"/>
							<input type="hidden" name="valid" value="' .$formValid. '">
						</div>
						<div class="btngroup">
							<input type="submit" id="listbtn" value="LOGIN">
						</div>
					</form>
				</div>
			</body>
		</html>';
		echo $OUT;

} elseif(isset($_SESSION['imgresize']['formvalid']) && isset($_POST['valid']) && $_POST['valid'] == $_SESSION['imgresize']['formvalid']) {
    //Preparing & validating POST data.
    if (isset($_POST['action'])) {

        $okay = true;

        switch ($_POST['action']) {

            case 'list':
				//For listing images.
                if (isset($_POST['recursive'])) {
                    $recursive = 1;
                } else {
                    $recursive = 0;
                }

                if (isset($_POST['shrinkonly'])) {
                    $shrinkOnly = 1;
                } else {
                    $shrinkOnly = 0;
                }

                if (!isset($_POST['unit'])) {
                    $okay = false;
                }
				
				if(!isset($_POST['minbyte']) || $_POST['minbyte'] == "" || !isset($_POST['useminbyte']) || $_POST['useminbyte'] == 0){
                    $minByte = 0;
				} elseif (is_numeric($_POST['minbyte']) && $_POST['minbyte'] > 0) {
                    $minByte = minByteSize((int) $_POST['minbyte'], $_POST['unit']);
				} else {
                    logMessage('Min-Filesize set incorrectly.');
                    $okay = false;
				}

				if(isset($_POST['dir'])){
					$dir =  $startDir . utf8_decode($_POST['dir']);
					if(!file_exists($dir)){
						$dir = $startDir;
					}
				} else {
						$okay = false;
				}

                switch ($_POST['method']) {

                    case 0:
						//Fix sides.
                        $lrgSide = 0;

                        if (is_numeric($_POST['width']) && $_POST['width'] > 0) {
                            $newWidth = (int) $_POST['width'];
                        } elseif ($_POST['width'] == "") {
                            $newWidth = 0;
                        } else {
                            logMessage('Fix-Width set incorrectly.');
                            $okay = false;
                        }

                        if (is_numeric($_POST['height']) && $_POST['height'] > 0) {
                            $newHeight = (int) $_POST['height'];
                        } elseif ($_POST['height'] == "") {
                            $newHeight = 0;
                        } else {
                            logMessage('Fix-Height set incorrectly.');
                            $okay = false;
                        }

                        if ($newWidth == 0 && $newHeight == 0) {
                            logMessage('Fix-Size data not set.');
                            $okay = false;
                        }

                        break;

                    case 1:
						//Biggest side.
                        $newWidth = 0;
                        $newHeight = 0;

                        if (is_numeric($_POST['lrgside']) && $_POST['lrgside'] > 0) {
                            $lrgSide = (int) $_POST['lrgside'];
                        } elseif ($_POST['lrgside'] == "") {
                            $lrgSide = 0;
                        } else {
                            logMessage('Largest-Side set incorrectly.');
                            $okay = false;
                        }

                        if ($lrgSide == 0) {
                            logMessage('Largest-Side not set.');
                            $okay = false;
                        }

                        break;

                    default:
                        logMessage('Method not set.');
                        $okay = false;
                        break;
                }

                if ($okay == true) {
                    //Gather user input into an array.
                    $resizeData = array(
                        'method' => $_POST['method'],
                        'lrgside' => $lrgSide,
                        'newwidth' => $newWidth,
                        'newheight' => $newHeight,
                        'shrinkonly' => $shrinkOnly,
                        'minbyte' => $minByte
                    );


                    $imageList = listImages($recursive, $dir);
                    if (empty($imageList)) {
                        logMessage('No images found that need to be resized.');
                    } else {
                        $result = array();
                        $i = 0;
                        $fullByteSize = 0;
                        foreach ($imageList as $image) {

                            $imageData = @getimagesize($image);
                            $newSize = newSize($imageData, $resizeData, $maxPxWrite);

                            if (check($imageData, $newSize, filesize($image), $resizeData, $maxPxRead)) {

                                $filename = mb_convert_encoding($image, "UTF-8");
                                $result[$i]['filename'] = $filename;
                                $result[$i]['shownfilename'] = str_replace($startDir, "", $filename);
                                $result[$i]['newwidth'] = $newSize[0];
                                $result[$i]['newheight'] = $newSize[1];
                                $result[$i]['width'] = $imageData[0];
                                $result[$i]['height'] = $imageData[1];
                                $fs = filesize($image);
                                $fullByteSize += $fs;
                                $result[$i]['filesize'] = $fs;
                                $i++;
                            }
                        }
                        $result = array($result, $fullByteSize);
                        if ($fullByteSize != 0) {
							//Return json array for jQuery to format.
                            echo json_encode($result);
                        }

                        return;
                    }
                }
                break;

            case 'resize':
				//For resizing images.

                if (isset($_POST['k']) && $_POST['k'] != 0) {
                    $keepOld = 1;
                } else {
                    $keepOld = 0;
                }

                if (isset($_POST['w']) && isset($_POST['h']) && isset($_POST['i'])) {

                    $image = utf8_decode($_POST['i']);
                    if (file_exists($image) && is_numeric($_POST['w']) && $_POST['w'] > 0 && is_numeric($_POST['h']) && $_POST['h'] > 0) {

                        $newSize[] = round($_POST['w']);
                        $newSize[] = round($_POST['h']);
						$newSize = limitMaxPx($newSize, $maxPxWrite);
                        $imageData = @getimagesize($image);
                        resizeImage($imageData, $newSize, $image, $keepOld);
                        $result = filesize($image);
                        echo $result;
                    }
                }
                break;
        }
    } else {
		//Sets default states for the from elements.
		$formData = array(
			'recursive' => '',
			'shrinkonly' => '',
			'useminbyte' => '',
			'keepold' => '',
			'minbyte' => '',
			'unit' => 'Byte',
			'method0' => 'checked',
			'method1' => '',
			'width' => '',
			'height' => '',
			'lrgside' => ''
		);
		//Unit select element's options.
		$unitTypes = array(
			'Byte',
			'kB',
			'MB',
			'GB',
		);

		$units = "";

		$formValid = mt_rand(1, 999999999); //nonce for form validation.
		if(isset($_SESSION['imgresize']['formvalid'])) unset($_SESSION['imgresize']['formvalid']);
		$_SESSION['imgresize']['formvalid'] = $formValid;

		foreach ($unitTypes as $unit) {
			$units .= '<option value="' . $unit . '" ' . ($formData['unit'] == $unit ? 'selected' : '') . '>' . $unit . '</option>';
		}

		//Directory select element's options.
		$foldersArray = array();
		listSubFolders($startDir, $foldersArray);
		$folders =  '<option value="' . $startDir . '">' . DIRECTORY_SEPARATOR . '</option>';
		foreach($foldersArray as $folder){
			$folder = mb_convert_encoding($folder, "UTF-8");
			$folder = str_replace($startDir, "", $folder);
			$folders .= '<option value="' . $folder . '">' . $folder . '</option>';
		}
		$OUT = '
		<!DOCTYPE html>
		<html>
			<head>
				<meta charset="UTF-8">
				<title>IMGResize</title>
				<link rel="stylesheet" type="text/css" href="' . $cssDir . 'base.css" />
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
				<script></script>
			</head>
			<body>
				<div class="container" id="main">
					<h1>IMG<strong>RESIZE</strong><span id="vnum">v1.0</span></h1>
					<div class="triangle"></div>
					<div id="process">
						<h3><span id="dspan">Process Done</span><span id="sspan">Process Stopped</span></h3>
						<h5></h5>
						<div id="pb-container">
						<div id="pb"></div>
						</div>
						<h4>Processing <a><span id="imgdone"></span>/<span id="imgtotal"></span></a> images</h4>
						<input id="stopbtn" type="button" value="STOP">
						<input id="closebtn" type="button" value="CLOSE">
					</div>
					<form action="' . $_SERVER['PHP_SELF'] . '" method="POST">
						<div class="box" id="dirbox">
							<label>DIRECTORY</label><select name="dir">' . $folders .
							'</select>
						</div>
						<div class="box">
							<input type="radio" name="method" id="method0" value="0" ' . $formData['method0'] . '>
							<label class="mainlabel" for="method0">
									<span class="icon"></span>Fixed size
									<span class="notice">Image width & height must be set as positive integers(max 4096), and least one of them must be set!</span></label><br />
								<label class="sizelabel" for="width"><strong>Image width</strong> <em>(Leave blank to not change)</em></label>
								<input type="number" class="method0" name="width" id="width" value="' . $formData['width'] . '"> px<br />
								<label class="sizelabel" for="height"><strong>Image height</strong> <em>(Leave blank to not change)</em></label>
								<input type="number" class="method0" name="height" id="height" value="' . $formData['height'] . '"> px<br />
						</div>
						<div class="box">
							<input type="radio" name="method" id="method1" value="1" ' . $formData['method1'] . '>
								<label class="mainlabel" for="method1">
									<span class="icon"></span>Bigger side
								<span class="notice">The bigger side must be set as a positive integer(max 4096)!</span></label><br />
								<label class="sizelabel" for="lrgside"><strong>Size of bigger side</strong></label>
								<input type="number" name="lrgside" id="lrgside" class="method1" value="' . $formData['lrgside'] . '"> px<br />
						</div>
						<div class="box" id="chbox">
							<input type="checkbox" name="shrinkonly" id="shrinkonly" value="1" ' . $formData['shrinkonly'] . '>
								<label class="mainlabel" for="shrinkonly"><span class="icon"></span>Don\'t increase image size</label><br />
							<input type="checkbox" name="recursive" id="recursive" value="1" ' . $formData['recursive'] . '>
								<label class="mainlabel" for="recursive"><span class="icon"></span>Recursive</label><br />
							<input type="checkbox" name="useminbyte" id="useminbyte" value="1" ' . $formData['useminbyte'] . '>
								<label class="mainlabel" for="useminbyte"><span class="icon"></span>
							<input type="number" name="minbyte" id="minbyte" value="' . $formData['minbyte'] . '">
							<select name="unit">' . $units .
							'</select>
							Only resize above this filesize
								<span class="notice">The minimum filesize must be set as a positive integer!</span></label><br />
							<input type="checkbox" name="keepold" id="keepold" value="1" ' . $formData['keepold'] . '>
								<label class="mainlabel" for="keepold"><span class="icon"></span>Keep the original image as *.old</label><br />
						</div>
						<div class="btngroup">
							<input id="listbtn" type="button" value="LIST">
							<input id="resizebtn" type="button" value="RESIZE">
						</div>
						</div>
						<div class="triangle" id="tr2">
						</div>
						<div class="container" id="list"></div>
						<input type="hidden" name="valid" value="' .$formValid. '">
						<input type="hidden" name="user" value="' .$_POST['user']. '">
						<input type="hidden" name="pw" value="' .$_POST['pw']. '">
					</form>
				</div>
					<script src="' . $jsDir . 'main.js"></script>
					<!-- www.20script.ir -->
			</body>
		</html>';
		echo $OUT;
	}
}
?>